/* 
 * Copyright (C) 2004 Francesco Stablum (DuskDruid)
 * <duskdruid _at_ inventati org> 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */


#include "myheaders.h"
void S_free(void *ptr)
{
  static unsigned int count=0;
  static unsigned int null_count=0;
  if (count<655335)
    count++;
  dprintf("S_free called %d times (NULLs received:%d, this pointer:%x)",
	 count,null_count,ptr);
  if(ptr!=NULL)
    {
      free(ptr);
      ptr=0; /* by Gimli :) */
    }
  else
    {
      if (null_count<655335)
	null_count++;
      dprintf("Warning: S_free caught NULL pointer %d times!",null_count);
    }

}

void *S_calloc(size_t nmemb, size_t size)
{
  void *ptr;
  static unsigned int calloc_count=0;
  if (calloc_count<655335)
      calloc_count++;
  dprintf("S_calloc called %d times!",calloc_count);
  if(nmemb<=0)
    {
      printf("Error: S_calloc caught `nmemb' argument =< 0!\n");
      printf("quitting...\n");
      bug();
    }
  
  if(size <=0)
    {
      printf("Error: S_calloc caught `size' argument =< 0!\n");
      printf("quitting...\n");
      bug();
    }
  ptr=(void *)calloc(nmemb,size);
  if(ptr==NULL)
    {
      printf("S_calloc: calloc returned NULL\n");
      printf("Error: no enough memory!\n");
      bug();
    }
  dprintf("S_calloc return pointer: %x",ptr);
  return (ptr);
}

void *S_malloc(size_t size)
{
  void *ptr;
  static unsigned int calloc_count=0;
  if (calloc_count<655335)
      calloc_count++;
  dprintf("S_malloc called %d times!",calloc_count);
  if(size<=0)
    {
      printf("Error: S_malloc caught `size' argument =< 0!\n");
      printf("quitting...\n");
      bug();
    }
  
  ptr=(void *)malloc(size);
  if(ptr==NULL)
    {
      printf("S_malloc: malloc returned NULL\n");
      printf("Error: no enough memory!\n");
      bug();
    }
  dprintf("S_malloc return pointer: %x",ptr);
  return (ptr);
}
