/* 
   snip code for the terminal colors is taken from 
   http://linuxgazette.net/issue65/padala.html 

   Copyright (c)2001, Pradeep Padala.
   Copying license http://www.linuxgazette.com/copying.html
   Published in Issue 65 of Linux Gazette, April 2001

   Note: I (Francesco Stablum) have modified the code on 15/01/04
   to take it useful for my program (tcpick) released under the GPL license.
*/

#include "myheaders.h" /* replaced "#include <stdio.h>" by Francesco Stablum "duskdruid" */

extern struct flags_t flags;

/* colors defines inserted in myheaders.h by Francesco Stablum "duskdruid" */

void textcolor(int attr, int fg, int bg);

/* warning: main function commented by Francesco Stablum "duskdruid" 
example 
int main()
{textcolor(BRIGHT, RED, BLACK);
 printf("In color\n");
 textcolor(RESET, WHITE, BLACK);
 return 0;
}
*/

void textcolor(int attr, int fg, int bg) 
{char command[13];
 if(flags.color) /* if statement added by Francesco Stablum "duskdruid" */
   {
     /* Command is the control command to the terminal */
     sprintf(command, "%c[%d;%d;%dm", 0x1B, attr, fg + 30, bg + 40);
     printf("%s", command);
     fprintf(stderr,"%s", command);
   }
}

/* all the following lines added by Francesco Stablum "duskdruid" */

void put_color(int attr, int fg, int bg) 
{
  if(flags.colortrack)
    tracked_textcolor();
  else
    textcolor(attr,fg,bg);
}

void resetcolor()
{
  textcolor(RESET, WHITE, BLACK);
}

void errcolor()
{
  textcolor(BRIGHT, RED, BLACK);
}

void infocolor()
{
  textcolor(BRIGHT, YELLOW, BLACK);
}

void highcolor()
{
  textcolor(BRIGHT, CYAN , BLACK);
}

void goodcolor()
{
  textcolor(BRIGHT, GREEN , BLACK);
}

void lowcolor()
{
  textcolor(RESET, YELLOW , BLACK);
}

void statuscolor()
{
  put_color(BRIGHT, YELLOW , BLACK);
}

void servicecolor()
{
  put_color(BRIGHT, BLUE , BLACK);
}

void serviceheadercolor()
{
  textcolor(RESET, BLUE , BLACK);
}

void establishedcolor()
{
  put_color(BRIGHT, GREEN , BLACK);
}

void closedcolor()
{
  put_color(BRIGHT, RED , BLACK);
}

void allstatusescolor(FILE * out,int status)
{
  if(out==stdout)
    {
      switch(status)
	{
	case 3:
	  {
	    establishedcolor();
	    break;
	  }
	case 7:
	  {
	    closedcolor();
	    break;
	  }
	default:
	  {
	    statuscolor();
	    break;
	  }
	}
    }
}

void numberingcolor()
{
  put_color(BRIGHT, MAGENTA , BLACK);
}

void servernamecolor()
{
  put_color(BRIGHT, CYAN , BLACK);
}

void servernameheadercolor()
{
  textcolor(RESET, CYAN , BLACK);
}

void clientnamecolor()
{
  put_color(BRIGHT, WHITE , BLACK);
}

void timecolor()
{
  put_color(BRIGHT, CYAN , BLACK);
}

void timeheadercolor()
{
  textcolor(BRIGHT, CYAN , BLACK);
}

void clientnameheadercolor()
{
  textcolor(BRIGHT, WHITE , BLACK);
}

void flagscolor()
{
  textcolor(BRIGHT, RED , BLACK);
}

void directioncolor()
{
  textcolor(BRIGHT, MAGENTA , BLACK);
}

void nonprintcolor()
{
  textcolor(RESET,RED , BLACK);
}

void firsthexcountcolor()
{
  textcolor(BRIGHT,WHITE , BLACK);
}

void hexcountcolor()
{
  textcolor(BRIGHT,CYAN , BLACK);
}

void hexasciicolor()
{
  textcolor(BRIGHT,WHITE , BLACK);
}

void payloadcolor()
{
  textcolor(RESET, WHITE, BLACK);
}
