/* 
 * Copyright (C) 2003 Francesco Stablum (DuskDruid)
 * <duskdruid @ inventati org> 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */

#include "myheaders.h"
int payload_len=0;

extern struct flags_t flags;

extern int ip_trasl;
extern int tcp_trasl;
extern int data_trasl;

int packet_counter=0;
struct ip *ippacket;
struct tcphdr *tcppacket;

u_char *payload;

u_int32_t tsval=0;
u_int32_t tsecr=0;
u_char opt_octet;
  int max_segsize=0;
  int opt_lenght=0;

void got_packet (u_char *useless,
		 const struct pcap_pkthdr* hdr,
		 const u_char* packet)
{



  packet_counter++;
  if(packet==NULL)
    {
      fprintf(stderr,"Didn't grab packet\n");
      bug();
    }
  
  
      
  payload_len=hdr->len-ip_trasl;
  payload_len-=tcp_trasl;
  payload_len-=data_trasl;
      ippacket=(struct ip *)(packet+ip_trasl);
      switch(ippacket->ip_p)
	{
	case IPPROTO_TCP:
	  {
	    tcppacket=(struct tcphdr *)(packet+ip_trasl+tcp_trasl);
	    //	  printf("source:%d;
	    //	  dest:%d!!!\n",ntohs(tcppacket->source),ntohs(tcppacket->dest));
	    /*print ip addresses, ports and flags*/	    
	    if(flags.displayheader>0)
	      {
		display_header(stdout,ippacket,tcppacket);
	      }
	    
	    
	    dprintf ("<%d. packet grabbed> [hdr->len:%d]", packet_counter,hdr->len);
	    dprintf("[seq:%u] [ack:%u]",ntohl(tcppacket->seq),ntohl(tcppacket->ack_seq));
	    dprintf("[data offset:%d] [window: %d]",
		    tcppacket->doff,
		    ntohl(tcppacket->window)
		    );

	    dprintf("[checksum: %u] [urgent pointer: %x]",
		    ntohl(tcppacket->check),
		    ntohl(tcppacket->urg_ptr)
		    );

	    payload=(u_char *)(packet+ip_trasl+tcp_trasl+data_trasl); 
	    opt_octet=*payload;
	    dprintf("1st option octet: %d",opt_octet);
	    switch (opt_octet)
	      {
	      case 0:
		{
		  payload++;
		  break;
		}
	      case 1:
		{
		  payload++;
		  if (*payload!=1)
		    {
		      dprintf("WARNING: strange 2nd option octet: %d",*payload);
		    }
		  else
		    {
		      dprintf("2nd option octet: %d",*payload);
		      payload++;
		      dprintf("3rd option octet: %d --Timestamp kind",*payload);
		      if(*payload!=8)
			dprintf("WARNING: 3rd option octet should be 8!");
		      payload++;
		      dprintf("4th option octet: %d --",*payload);
		      if (*payload!=10)
			{
			  dprintf("WARNING: 4th option octet should be 10!");
			}
		      
		      payload++;
		      tsval=*payload;
		      dprintf("tsval: %d",tsval);
		      payload+=4;
		      tsecr=*payload;
		      dprintf("tsecr: %d",tsecr);
		      payload+=4;
		    }
		  
		  break;
		}
	      case 2:
		{
		  
		  payload++;
		  opt_lenght=*payload;
		  dprintf ("2nd option octet: %d --option lenght",max_segsize);
		  payload++;
		  max_segsize=(int)*payload;
		  dprintf ("3rd option octet: %d --max seg.size",max_segsize);
		  payload+=opt_lenght-2;
		  
		  break;
		}
	      default:
		{
		  //	    payload++;
		  break;
		}
	      }
	    
	    
	    /* data section */
	    payload_len=hdr->len-(int)(payload-packet);/*calculate lenght of data section*/
	    verify(ippacket,tcppacket,payload,payload_len); /* verify the packet*/
	    dprintf("DATA section (%d bytes, after %d bytes of header)",
		    payload_len,
		    (int)(payload-packet)
		    );
	    
	    if(flags.hexdump)
	      if(flags.hexasciidump)
		display_dump(stdout,payload,payload_len,1,0);
	      else
		display_dump(stdout,payload,payload_len,0,0);
	    else
	      if(flags.displaydata>0)
		display_data(stdout,
			     payload,
			     payload_len,
			     flags.displayraw,
			     1,
			     flags.displayhexnonprint);

	    if(flags.writeheaders)
	      {
		/* FIXME */
	      }
	  }
	  break;
	  
	default: /* non-TCP packet */
	  {
	    dprintf("non-TCP packet caught: %s > %s",
		    inet_ntoa(ippacket->ip_src),
		    inet_ntoa(ippacket->ip_dst)
		    );	    
	  }
	}
}
