/* 
 * Copyright (C) 2003 Francesco Stablum (DuskDruid)
 * <duskdruid @ inventati org> 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */
#include "myheaders.h"
extern int debug_flag;

int match(
	  struct conn_t * conn, /* the connection to analyze */
	  struct ip *ippacket, 
	  struct tcphdr *tcppacket,
	  
	  int part, /* should it be client(1) or server (2) 
		       or can be both(3) sending this
		       packet? (-1 means neutrality) */

	  int status, /* status requested (-1 = any status)*/

	  int urg,/* for tcp flags -1 means neutrality */
	  int ack,
	  int psh,
	  int rst,
	  int syn,
	  int fin
	  )
     /* function match(): does alle requirment sathisfy all conditions?*/
{
  int resulting_bool=1; /* this should be always 1 although
			   contraddiction */
  int tmp_bool=1;
  /* tcp flags test */

  if(urg!=-1)
    {
      if(!(tcppacket->urg==urg&&resulting_bool==1))
	return 0;
    }
  if(ack!=-1)
    {
      if(!(tcppacket->ack==ack&&resulting_bool==1))
	return 0;
    }
  if(psh!=-1)
    {
      if(!(tcppacket->psh==psh&&resulting_bool==1))
	return 0;
    }
  if(rst!=-1)
    {
      if(!(tcppacket->rst==rst&&resulting_bool==1))
	return 0;
    }
  if(syn!=-1)
    {
      if(!(tcppacket->syn==syn&&resulting_bool==1))
	return 0;
    }
  if(fin!=-1)
    {
      if(!(tcppacket->fin==fin&&resulting_bool==1))
	return 0;
    }
  if(part!=-1)
  /* part test (client or server?)*/
    {
      if(part>0&&conn==NULL)
	return 0;
      if(part==1)
	{
	  
	  if(!(conn->client_ip==ippacket->ip_src.s_addr&&
	       conn->server_ip==ippacket->ip_dst.s_addr&&
	       conn->client_port==tcppacket->source&&
	       conn->server_port==tcppacket->dest
	       )) return 0;
	  
	  /* client sending data*/
	}
      if(part==2)
	{
	  if( ! (conn->client_ip==ippacket->ip_dst.s_addr&&
		 conn->server_ip==ippacket->ip_src.s_addr&&
		 conn->client_port==tcppacket->dest&&
		 conn->server_port==tcppacket->source
		 )) return 0;
	  /* server sending data */
	}
      if(part==3)
	{
	  if( ! ((conn->client_ip==ippacket->ip_src.s_addr&&
		  conn->server_ip==ippacket->ip_dst.s_addr&&
		  conn->client_port==tcppacket->source&&
		  conn->server_port==tcppacket->dest
		  )
		 &&
		 (conn->client_ip==ippacket->ip_dst.s_addr&&
		  conn->server_ip==ippacket->ip_src.s_addr&&
		  conn->client_port==tcppacket->dest&&
		  conn->server_port==tcppacket->source
		  ))) return 0;
	  /* client or server sending data */
	}
    }
  if(status!=-1)
    {
      if(!(conn->status==status))
	return 0;
    }
  
  return(1);
}

