#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <stdarg.h>
#include <errno.h>

#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif

#include <sys/types.h>

#include <sys/socket.h>
#include <arpa/inet.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>

#ifdef HAVE_NET_BPF_H
#include <net/bpf.h>
#else
#ifdef HAVE_PCAP_BPF_H
#include <pcap-bpf.h>
#else
/* error message: don't have bpf.h */
#endif
#endif

#ifdef HAVE_NETINET_IN_SYSTM_H
#include <netinet/in_systm.h>
#endif

#ifndef HAVE_NETINET_IP_H
#include "ip.h"
#else
#include <netinet/ip.h>
#endif

#include <netdb.h>

#ifdef HAVE_PCAP_PCAP_H
#include <pcap/pcap.h>
#else
#include <pcap.h>
#endif

#include "tcp.h"
#include "conn_t.h"
#include "flags_t.h"

#ifdef HAVE_TIME_H
#include "time.h"
#endif

#ifdef HAVE_SYS_TIME_H
#include "sys/time.h"
#endif


#define MAXCONN 16384
#define MAXMALLOC 16777216

#define RESET 0
#define BRIGHT 1
#define DIM 2
#define UNDERLINE 3
#define BLINK 4
#define REVERSE 7
#define HIDDEN 8

#define BLACK 0
#define RED 1
#define GREEN 2
#define YELLOW 3
#define BLUE 4
#define MAGENTA 5
#define CYAN 6
#define WHITE 7

