/* 
 * Copyright (C) 2003, 2004 Francesco Stablum (DuskDruid)
 * <duskdruid _at_ inventati _dot_ org> 
 * (please use mailing-list below instead)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */

/* 
 * tcpick project needs somebody suggesting me bugs and new features!
 * If you want to contribute sending patches, finding bugs, compilation
 * errors, platform-specific incompatibilies you are invited to the tcpick
 * mailing-list:
 *
 * email address: 
 *   <tcpick-project@lists.sourceforge.net>
 * Archive:
 *   http://sourceforge.net/mailarchive/forum.php?forum=tcpick-project
 * Subscribe:
 *   http://lists.sourceforge.net/lists/listinfo/tcpick-project
 */


#include "myheaders.h"

#define AUTHOR "Francesco Stablum `DuskDruid' < "PACKAGE_BUGREPORT">"
#define EXAMPLEARGS "-i ppp0 -P -C -h \"not port 22\""
#define BUFFSIZ 16384
#define TERMS "tcpick is released under the GPL license\n and comes with ABSOLUTELY NO WARRANTY.\n This is free software, and you are welcome to redistribute it\n under certain conditions; for details read COPYING file.\n"
#define OPTIONS "[ -d ] [ -a ]\n"\
          "\t[{ -i | --interface } interface ]\n"\
          "\t[ \"filter\" ]\n" \
	  "\t[ -v [ verbosity ] ]\n"\
	  "\t[{ -s | --silent }] ]\n" \
	  "\t[{ -h | --show-header }]\n"\
	  "\t[{ -C [{ 1 | 2 }] | --colors }]\n"\
	  "\t[{ -P | --show-printable }]\n"\
	  "\t[{ -R | --show-raw ]\n"\
	  "\t[{ -H | --show-hex }]\n"\
	  "\t[{ -U | --show-hexnonprint }]\n"\
	  "\t[{ -x | -show-hexdump }]\n"\
	  "\t[{ -X | --show-hexasciidump }]\n"\
	  "\t[ -w[h][PRUxX] ]\n"\
	  "\t[{ -r | --readfile } file ]\n"\
	  "\t[ --help ] [ --version ]\n\n"
extern struct conn_t * first_conn;
extern struct conn_t * last_conn;

struct flags_t flags;


char *exe;
  char *datalink=NULL;
  char *dev=NULL; /* name of the device to use */
  char *readfile=NULL; /* name of the file to read */
  char *net; /* dot notation of the network address */
  char *mask; /* dot notation of the network mask */
  int ret=0; /* return code*/
  int datalinkid=0;

  char *errbuf[PCAP_ERRBUF_SIZE];
  char *filter=NULL;
struct bpf_program filter_compiled;
  bpf_u_int32 netp; /* ip */
  bpf_u_int32 maskp; /* subnet mask */
  struct in_addr addr;
  char current_option;
char *other_args=NULL;
  pcap_t *descr;
  const u_char *packet;
  u_char *curr_char;
  int curr_pos=0;
  struct pcap_pkthdr hdr;
  int ip_trasl=0;
  int tcp_trasl=0;
  int data_trasl=0;


extern void got_packet();
int usage()
{
  infocolor();
  fprintf(stderr,"\n %s is a sniffer tool written using libpcap.\n",PACKAGE_STRING);
  fprintf(stderr," tcpick can keep track of tcp connection, sniff all tcp streams\n"
	         " and store them to files, to show you what is happening on a network interface\n\n");
  fprintf(stderr," Usage: %s %s",
	  exe,OPTIONS);
  fprintf(stderr," Example: %s %s\n\n",exe,EXAMPLEARGS);
  fprintf(stderr," for an updated list of options see tcpick(1) manpage\n");
  fprintf(stderr," try `man 1 tcpick'\n");
  fprintf(stderr," to see version and license informations try `%s --version'\n",exe);
  fprintf(stderr," or read the `COPYING' file, released with the package\n\n");
  fprintf(stderr," tcpick homepage: http://tcpick.sourceforge.net\n\n");
  fprintf(stderr," mailing-list:\n"
	  "\temail address:\n"
	  "\t\t<tcpick-project@lists.sourceforge.net>\n"
	  "\tArchive:\n"
	  "\t\thttp://sourceforge.net/mailarchive/forum.php?forum=tcpick-project\n"
	  "\tSubscribe:\n"
	  "\t\thttp://lists.sourceforge.net/lists/listinfo/tcpick-project\n\n"
	  "thank you for using tcpick!\n"
	  );
  resetcolor();
  exit(0);
}
int bug()
{
  errcolor();
  fprintf(stderr,"Please send a bugreport to the following mailing-list\n"
	  "email address:\n"
	  "\t<tcpick-project@lists.sourceforge.net>\n"
	  "Archive:\n"
	  "\thttp://sourceforge.net/mailarchive/forum.php?forum=tcpick-project\n"
	  "Subscribe:\n"
	  "\thttp://lists.sourceforge.net/lists/listinfo/tcpick-project\n"
	  "don't forget to specify OS, kernel version and tcpick version!"
	  );

  exit(-1);
  resetcolor();
}

int main(int argc, char **argv) 
{

#ifdef HAVE_GETOPT_LONG
  static struct option long_options[]=
    {
      {"version",no_argument, &(flags.versionandquit),1},
      {"help",no_argument, &(flags.helpandquit),1},
      {"silent",no_argument, 0,'s'},
      {"show-header",no_argument, 0,'h'},
      {"interface",required_argument, 0, 'i'},
      {"readfile",required_argument, 0, 'r'},
      {"show-raw",no_argument, 0, 'R'},
      {"show-hex",no_argument, 0,'H'},
      {"show-hexnonprint",no_argument,0,'U'},
      {"show-printable",no_argument,0,'P'},
      {"show-hexdump",no_argument, 0, 'x'},
      {"resolv-names",no_argument, 0, 'a'},
      {"show-hexasciidump",no_argument,0,'X'},
      {"numerical-services",no_argument,0,'n'},
      {"colors",no_argument,0,'C'},
      {0,0,0,0}
    };
#endif
  
  int option_index=0;

  if (argc==1)
    printf("important: `man 1 tcpick' explains all options available\n");
  exe=(char *)strdup(argv[0]);
#if HAVE_GETOPT_LONG
  while ((current_option=getopt_long(argc,argv,"ac:C::dhHi:m:nPr:RsSuUv::w::xX",long_options, &option_index))!=-1)
#else
    printf("Your system doesn't support getopt_long() function; you will be "
	   "unable to use the long options\n"
	   " i.e. `% tcpick --interface ppp0' DOESN'T WORK! \n");
  /* remember: NOT DOUBLE COLONS HERE (::)  */
  while ((current_option=getopt(argc,argv,"ac:C:dhHi:m:nPr:RsSuUv:w:xX"))!=-1)
#endif
    
    switch(current_option)
      {
      case 'a':
	{
	  flags.resolv=1;
	  break;
	}
      case 'c':
	{
	  if ((flags.maxconns=atoi(optarg))==0) /* FIXME !!! */
	    {
	      errcolor();
	      fprintf(stderr,"%s: invalid number of maximum connections\n",optarg);	      exit(-1);
	      resetcolor();
	    }
	  flags.maxconns=1;
	  break;
	}
      case 'C':
	{
	  flags.color=1;
	  if(optarg!=NULL)
	    switch(atoi(optarg))
	      {
	      case 1:
		{
		  flags.color=1;
		  break;
		}
	      case 2:
		{
		  flags.colortrack=1;
		  break;
		}
	      default:
		{
		  fprintf(stderr,"%s: invalid color option\n",optarg);
		  exit(-1);
		}
	      }
  	  break;
	}
      case 'i':
	{
	  dev=optarg;
	  break;
	}
      case 'u': //get the first
	{
	  break;
	}
      case 'v':
	{
	  if (optarg!=NULL)
	    {
	      flags.verbose=strtol(optarg,(char **)NULL, 10);
	      if (flags.verbose <0 || flags.verbose>5)
		{
		  errcolor();
		  fprintf(stderr,"%s: invalid verbosity number\n",optarg);
		  resetcolor();
		  exit(-1);
		}
	      if (flags.verbose==0)
		flags.silent=1;
	    }
	  else
	    flags.verbose=1;
	  break;
	}
      case 'd': //debug mode
	{
	  flags.debug=1;
	  flags.verbose=5;
	}
      case 'm':
	if (optarg!=NULL)
	  if ((flags.mode=atoi(optarg))==0)
	    {
	      errcolor();
	      fprintf(stderr,"%s: invalid mode number\n",optarg);
	      resetcolor();
	      exit(-1);
	    }
	break;
      case 'x':
	{
	  flags.hexdump=1;
	  break;
	}
      case 'X':
	{
	  flags.hexdump=1;
	  flags.hexasciidump=1;
	  break;
	}
      case 'h':
	{
	  flags.displayheader=1;
	  break;
	}
      case 'H':
	{
	  flags.displayhex=1;
	  break;
	}
      case 's':
	{
	  flags.silent=1;
	  break;
	}
      case 'r':
	{
	  readfile=optarg;
	  break;
	}
      case 'R':
	{
	  flags.displayraw=1;
	  break;
	}
      case 'P':
	{
	  flags.displaydata=1;
	  break;
	}
      case 'U':
	{
	  flags.displaydata=1;
	  flags.displayhexnonprint=1;
	  break;
	}
      case 'n':
	{
	  flags.numericalports=1;
	  break;
	}
      case 'w':
	{
	  if(optarg!=NULL)
	    {
	      int count;
	      for(count=0;count<strlen(optarg);count++)
		{
		  switch(*(optarg+count))
		    {
		    case 'P':
		      {
			flags.writeprintable=1;
			flags.file=1;
			flags.writeraw=0;
			break;
		      }
		    case 'x':
		      {
			flags.writehexdump=1;
			flags.file=1;
			flags.writeraw=0;
			break;
		      }
		    case 'X':
		      {
			flags.writehexasciidump=1;
			flags.file=1;
			flags.writeraw=0;
			break;
		      }
		    case 'R':
		      {
			flags.file=1;
			flags.writeraw=1;
			break;
		      }
		    case 's':
		      {
			flags.file=0;
			flags.writesilent=1;
			flags.writeraw=0;
			break;
		      }
		    case 'S':
		      {
			flags.file=1;
			flags.writestatus=1;
			break;
		      }
		    case 'U':
		      {
			flags.writehexnonprint=1;
			flags.file=1;
			flags.writeraw=0;
			break;
		      }
		    case 'h':
		      {
			flags.file=1;
			flags.writeheaders=1;
			break;
		      }
		    default:
		      {
			errcolor();
			fprintf(stderr,"Unrecognized write option: %c\n",*(optarg+count));
			resetcolor();
			break;
		      }

		    }
		}
	    }
	  else /* no -w argumens*/
	    {
	      flags.file=1;
	      flags.writeraw=1;
	    }



	  break;
	}
	//	default:
	//  printf("Unrecognized arguments: %s\n",optarg);
	
      }
  filter=argv[optind];
  /* setting the flags properly */
  if (flags.verbose>=1)
    flags.displayheader=1;
  if (flags.verbose>=2)
    flags.displaydata=1;
  if(flags.displayraw||
     flags.displayhex||
     flags.displayhexnonprint
     )
    flags.displaydata=1;
  if(flags.versionandquit)
    {
      infocolor();
      printf("%s\n",PACKAGE_STRING);
      printf(" Author: %s\n",AUTHOR);
      printf(" for other info try `man 1 tcpick', or `%s --help'\n\n",exe);
      printf(" %s\n",TERMS);
      resetcolor();
      exit(-1);
    }
  if(flags.helpandquit)
    {
      usage();
      exit(-1);
    }
  /* the code */
  if(!flags.silent)
    {
      highcolor();
      printf("Starting %s on %s",PACKAGE_STRING,get_actual_time()); 
      //newline carachter is in get_actual_time() string
      resetcolor();
    }
  if (getuid())
    {
      errcolor();
      fprintf(stderr,"you should be *root* to run %s\n",PACKAGE_STRING);
      resetcolor();
    }
  /* making the filter working */
  if (dev==NULL && readfile==NULL)
    {
      dev=pcap_lookupdev((char*)errbuf);
    }
  if (dev==NULL && readfile==NULL)
    {
      errcolor();
      fprintf(stderr,"%s\n",errbuf);
      resetcolor();
      exit(-1);
    }
  if (!flags.silent)
    {
      goodcolor();
      if (readfile)
	{
	  printf("%s: reading from %s\n",exe,readfile);
	} else {
	  printf("%s: listening on %s\n",exe,dev);
	}
      resetcolor();
    }
  if (dev)
    {
      /* ask pcap for the network address and mask of the device */
      ret=pcap_lookupnet(dev,&netp,&maskp,(char *)errbuf);
      if (ret==-1)
	{
	  errcolor();
	  fprintf(stderr,"%s\n",errbuf);
	  resetcolor();
	  exit(-1);
	}

      addr.s_addr = netp;
      net=(char *)strdup(inet_ntoa(addr));
      if (net==NULL)
	{
	  perror ("inet_ntoa");
	  bug();
	}
      addr.s_addr=maskp;
      mask=(char *)strdup(inet_ntoa(addr));
      if (mask == NULL)
	{
	  perror("inet_ntoa");
	  bug();
	}
    }

  
  /* section C: Let's GO! */
  
  if (dev && readfile)
    {
      errcolor();
      fprintf(stderr,"Please specify either a file (with -r <filename>)\n"
	      "   or an interface (with -i <int>), not both\n");
      resetcolor();
      exit(-1);
    }
  if (!readfile)
    {
      descr = pcap_open_live(dev,BUFSIZ,0,-1,(char *)errbuf);
    } else {
      descr = pcap_open_offline(readfile,(char *)errbuf);
    }
  if (descr==NULL)
    {
      errcolor();
      fprintf(stderr,"%s\n",errbuf);
      resetcolor();
      exit(-1);
    }

  /* compiling the filter */
  if (filter!=NULL)
    {
      if (!flags.silent)
	highcolor();
        printf ("setting filter: \"%s\"\n",filter);
	resetcolor();
	if((pcap_compile(descr,&filter_compiled,filter,0,(int)net)==-1)&&(!flags.silent))
	  {
	    errcolor();
	    fprintf(stderr,"error compiling filter \"%s\"\n",filter);
	    resetcolor();
	  }
	pcap_setfilter(descr,&filter_compiled);
    }

  datalinkid=pcap_datalink(descr);
  datalink=(char *)datalinktoa(datalinkid);
  dprintf ("Using device: %s - net: %s - mask: %s - datalink: %s\n",dev,net,mask,datalink);
  
  ip_trasl=datalinktooffset(datalinkid);
  dprintf ("ip header pointer offset set at: +%d\n",ip_trasl);

 tcp_trasl=20;
 dprintf ("tcp header pointer offset (from ip header) set at: +%d\n",tcp_trasl);

 data_trasl=20;
 dprintf ("data pointer offset (from tcp header) set at: +%d\n",data_trasl);

 first_conn=(struct conn_t *)S_calloc(sizeof(struct conn_t),1);
 last_conn=first_conn;

 /* section D: the loop */
 pcap_loop(descr,
	   -1,
	   got_packet,
	   NULL); 
 
 if (readfile)
   {
     printf("%s: done reading from %s\n",exe,readfile);
     exit (0);
   }
}
      

