/*
Copyright (C) 2003, 2004  Francesco Stablum "DuskDruid"

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "myheaders.h"

extern struct flags_t flags;

FILE * open_file(struct conn_t * conn_ptr)
{

  char * filename;
  char * clientname=(char *)cache_getnamebyip(conn_ptr->client_ip);
  char * servername=(char *)cache_getnamebyip(conn_ptr->server_ip);
  int server_port=conn_ptr->server_port;

  /* preparing for the client file*/
  filename=(char *)S_calloc(256,1);
  sprintf(filename,"client_%s",
	  clientname
	  );
  sprintf(filename,"%s_%s:%s",
	  filename,
	  servername,
	  getportname(server_port)
	  );
  conn_ptr->client_file=fopen(filename,"a");
  if(conn_ptr->client_file==NULL)
    {
      perror("[open_file] fopen client file");
      bug();
    }
  
  conn_ptr->client_filename=filename;

  /* preparing for the server file*/
  filename=(char *)S_calloc(256,1);
  sprintf(filename,"server_%s",
	  clientname
	  );
  sprintf(filename,"%s_%s:%s",
	  filename,
	  servername,
	  getportname(server_port)
	  );

  conn_ptr->server_file=fopen(filename,"a");
  if(conn_ptr->server_file==NULL)
    {
      perror("[open_file] fopen server file");
      bug();
    }
  conn_ptr->server_filename=filename;

  conn_ptr->file_opened=1;
}
int write_data_choosemode(FILE * thefile,u_char * payload,int payload_len)
{
  if(!flags.writesilent)
    {
      if(flags.writehexdump)
	display_dump(thefile,payload,payload_len,0,0);
      else
	if(flags.writehexasciidump)
	  display_dump(thefile,payload,payload_len,1,0);
	else
	  if(flags.writehexnonprint)
	    display_data(thefile,payload,payload_len,0,1,1);
	  else
	    if(flags.writeprintable)
	      display_data(thefile,payload,payload_len,0,1,0);
	    else
	      if(flags.writeraw)
		display_data(thefile,payload,payload_len,1,1,0);
    }
}
int file_write(struct conn_t * conn_ptr,
	       u_char * payload,
	       int payload_len,
	       Part side /*client (1) or server (2) ? */
	       )
{ 
  int curr_pos; 
  FILE *thefile; /* file descriptor target */
  u_char * data_ptr;
  int data_size;

  if(side==CLIENT)
    {
      thefile=conn_ptr->client_file;
      data_size=conn_ptr->client_data_size;
      fflush(conn_ptr->client_file);
    }
  else /* side==SERVER */
    {
      thefile=conn_ptr->server_file;
      data_size=conn_ptr->server_data_size;
      fflush(conn_ptr->server_file);
    }

  if(flags.writeraw)
    for(curr_pos=0;curr_pos<=data_size;curr_pos++)
      {
	fwrite(payload, payload_len,1,thefile);
	if(ferror(thefile))
	  {
	    dprintf("[file_write] write() wrote %i bytes",payload_len);
	  }
	else
	  /* error */
	  {
	    perror("[file_write] write()");
	    bug();
	  }
      }
  else
    write_data_choosemode(thefile,payload,payload_len);
}


int write_banners_and_data(struct conn_t * conn_ptr, struct ip * ippacket, struct tcphdr * tcppacket,u_char * payload,int payload_len)
{
  if(flags.writeheaders
     ||
     flags.writestatus
     ||
     flags.writeoffset) 
    {
      FILE * thefile;
      if (conn_ptr->file_opened==0)
	{
	  open_file(conn_ptr);
	}
      if(flags.writeheaders)
	{
	  display_header(conn_ptr->client_file,ippacket,tcppacket);
	  display_header(conn_ptr->server_file,ippacket,tcppacket);
	}
      
      if(conn_ptr->client_ip==ippacket->ip_src.s_addr)
	thefile=conn_ptr->client_file;
      else
	thefile=conn_ptr->server_file;
      write_data_choosemode(thefile,payload,payload_len);
    }
}
